
import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import org.jfree.chart.ChartUtilities;
import java.io.BufferedWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Date;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.math.RoundingMode;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.text.*;
import com.prediktormedical.drdaq.jni.*;
import com.JfreeChart.*;



public class TestDrDAQ{


	
	
    private JavaAdapter4DrDAQ drDAQ;
    private DynamicTimeSeriesChart DynamicPlot;
    
    
    private static float readOutScope;
    private static float readOutExt;
    private static float readOutTemp;
    private static float readOutR;
    private static float temp;
    private static int count = 0;
   
    
    private static float dataScope;
    private static float dataExt;
    private static float[] dataStorageScope;
    private static float[] dataStorageExt;
    private static double[] averageData;
    private static double[] last10FSR = new double[10];
    //private static double averageSum;
    private static double fsrAverageValue;
    
    private static int timeInSeconds;
    private static int sample;
    private static int iteration;
    private static double logdataScope;
    private static double logdataExt;
    
    //private static String timestamps;
    private static String timestampHeading;
	private String timestampEnding;
	private String filename;
	private String filenameBackup;
	private String filenameComp;
	private String filenameCompBackup;
	private String timestamps;
	private String filenameTimestamp;
	public String filenamePNG;
	public String filenamePNGbackup;
    
    
	private static Date date = new Date();
	
	private SimpleDateFormat sdfHeading;
	private SimpleDateFormat sdfEnding;
	private SimpleDateFormat sdfTimestamp;
	private SimpleDateFormat sdfTimestampRealTime;
	private SimpleDateFormat sdfFilename;
	
	private DecimalFormat dataFormat;
	private DecimalFormat tempFormat;
	private String channel;
	
	
	private static Scanner scan;
	public boolean comparison;  // = DynamicPlot.compare;
	private static boolean realtime;

	
	
	
	
	
    private void open(){
        if(drDAQ==null){
                try {
                    drDAQ = new JavaAdapter4DrDAQ();
                } catch (Exception e) { 
                    System.out.println( "Unable to load Java Adapter, check that java.library.path points to usbdrdaqjni dynamic lib, " + e.getMessage());
                    return;
                }
            }
            if(drDAQ.openDrDAQ()!=0){
                System.out.println("Unable to connect to DrDAQ, is the DrDAQ logger connected?");
                return;
            }
            System.out.println("External sensor connected");
            System.out.println("    ");
        	System.out.println("    ");    	
    }
    
    public void close(){
		if(drDAQ!=null)drDAQ.closeDrDAQ();
		System.out.println("Closed");
	}

    public void read(){
       
    	readOutScope = drDAQ.readScope();
    	readOutExt = drDAQ.readExt2();
    	readOutR = drDAQ.readResistance();
    	readOutTemp = drDAQ.readTemp();
    	Date currentDate = new Date();
    	timestamps= ""+sdfTimestamp.format(currentDate);
//    	DynamicPlot.addValue(readOutExt);
//    	DynamicPlot.addAverageValue(averageFSR(readOutExt));
   
    	DynamicPlot.addValue(readOutR);
    	DynamicPlot.addAverageValue(averageFSR(readOutR));
        	
			
			
			
		
	
        
    }

    public static void main(String[] args) throws Exception{
    	TestDrDAQ t = new TestDrDAQ();
    	

    	
    	t.DynamicPlot = new DynamicTimeSeriesChart("Test");

       
        while(t.DynamicPlot.startLogging == false){
        
        	Thread.sleep(0);				//enable input from other threads
        	
        }
        
        
        
        t.compareData(t.DynamicPlot.compare);
    	t.createBackupFile(t.DynamicPlot.workstation);
    	
    	
    	
    	
    	System.out.println("------------------");
    	System.out.println("------------------");
    	System.out.println("------------------");
    	
    	System.out.println(Paths.get(t.filenameBackup));
    	
    	System.out.println("------------------");
    	System.out.println("------------------");
    	System.out.println("------------------");
    	
    	
    	while(t.checkPath() == false){
    		t.DynamicPlot.getFilenameBackupPATH(Paths.get(t.filenameBackup));
    		while(t.DynamicPlot.startLogging == false){
    			t.createBackupFile(t.DynamicPlot.workstation);
    			t.checkPath();
            	Thread.sleep(2000);				//disable console spam
            	
            }
    	}
    	
    	t.DynamicPlot.setFilenamePNG(t.filenamePNG);
    	
    	
    	
//    	t.createBackupFile(t.DynamicPlot.workstation);
//    	t.DynamicPlot.setFilenamePNG(t.filenamePNG);
//    	t.DynamicPlot.getFilenameBackupPATH(Paths.get(t.filenameBackup));
   	
    	
    	
    	
    	
    	
    	
    	t.open();
    	t.synchronize();
    	t.createFile();
    	
    	averageData = new double[timeInSeconds];
    	
    	dataStorageExt = new float[timeInSeconds];
    	
    	if(t.DynamicPlot.compare == false){
    		t.runRegular();
    	}else{
        	t.runCompare();

    	}

    	t.close();
        
        
        
        
      
    }
 
    
    public boolean checkPath(){
    	
    	boolean pathExists;
    	if(Files.notExists(Paths.get(filenameBackup))){
    		pathExists = false;
    	}else{
    		pathExists = true;
    	}
    	
    	return pathExists;
    }
    
    
    
    private void realTime() {
    	System.out.println("\n Sample per second or system default?.");
    	System.out.println("[1] Per second \n[2] System default");
    	int input = scan.nextInt();
		  
		    switch(input){
	    	case 1:
	    		realtime = false;
	    		break;
	    	case 2: 
	    		realtime = true;
	    		break;
			default:
				System.out.println("Incorrect input.\n");
				realTime();
				break;
	    	
	    	}
	}

	public void runRegular(){
    	
    	 long millisAfter = System.currentTimeMillis();
         
         for(iteration=0; iteration<timeInSeconds;iteration++) { 
     		read(); 
     		
     		
     	
     		    		
     		//dataScope = readOutScope;
//     		dataExt = readOutExt;
     		dataExt =readOutR;
     		
     		
     		//logdataScope = (float) readOutScope;
//     		logdataExt = (float) readOutExt;
     		logdataExt = (float) readOutR;
     		
 			//dataStorageScope[iteration] = readOutScope; //used to calculate mean value
// 			dataStorageExt[iteration] = readOutExt; //used to calculate mean value
     		dataStorageExt[iteration] = readOutR;
 			
 			 			
 			sample = iteration+1;
 			temp = readOutTemp;
             
 			
 			
//			for(int i = 0; i <last10AverageData.length; i++){
//				last10AverageData[0] = (float) readOutExt; 					
//			}
			
             
             System.out.println( sample + "	\t" + readOutR + "\t"+ readOutExt);
//             System.out.println("average: " + averageFSR(readOutExt));
             System.out.println("average: " + averageFSR(readOutR));
             //System.out.println(last10AverageData[iteration]);
             if(sample%5 ==0){
             	System.out.println("Sample \t\t Resistance \t\t Ext");
             }
            
             long millis = System.currentTimeMillis();
             
             
             
             writeToFILE(); 
            
         
             
            if(realtime == false){
	 	        if(1000-millis+millisAfter > 0){
	 	        	try {
						Thread.sleep(1000-millis+millisAfter);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
	 	        }
            }
            
 	        
 	        millisAfter = System.currentTimeMillis();

 		
 	       count++;
 		}
        
     }
     
    public void runCompare(){
    	 long millisAfter = System.currentTimeMillis();
         
         for(iteration=0; iteration<timeInSeconds;iteration++) { 
     		read(); 
     		
     		
     		
     		    		
     		//dataScope = readOutScope;
     		dataExt = readOutExt;
     	
     		//logdataScope = (float) readOutScope;
     		logdataExt = (float) readOutExt;
     		
     		
 			//dataStorageScope[iteration] = readOutScope; //used to calculate mean value
 			dataStorageExt[iteration] = readOutExt; //used to calculate mean value
             sample = iteration+1;
             temp = readOutTemp;
             
             if(channel == "scope")
             {       
             
             
             System.out.println( sample + "	\t" + readOutScope + "	\t" + logdataScope + "	\t" + convertFloatsToDoublesDATAscope(dataScope));
             if(sample%5 ==0){
             	//System.out.println("Ambient temperature: " + temp);
             	System.out.println("Sample \t\t float \t\t double \t\t rounded");
             }
             }
             else{
            	 System.out.println( sample + "	\t" + readOutExt + "	\t" + logdataExt + "	\t" + convertFloatsToDoublesDATAext(dataExt));
                 if(sample%5 ==0){
                 	//System.out.println("Ambient temperature: " + temp);
                 	System.out.println("Sample \t\t float \t\t double \t\t rounded");
                 }
             }
             long millis = System.currentTimeMillis();
             
             
             
             writeToFileComparison();
             
             
             
             
             
 	        if(1000-millis+millisAfter > 0){
 	        	try {
					Thread.sleep(1000-millis+millisAfter);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
 	        }
 	        
 	        millisAfter = System.currentTimeMillis();

 		

 		}
        
    }
     
    public void compareData(boolean input){
    	  	
//    	 input = DynamicPlot.compare;
		 
    	 if(input == false){
	    		comparison = false;
	    		}
    	 else if(input == true){
	    		comparison = true;
	    		}
    }
        
    public void createFile(){

    	generateTimeHeaders();
    	
    	if(comparison == false){
    	
	    	filename = "log\\LogData_"+filenameTimestamp+".txt";
	    	filenamePNG = "log\\PNG\\LogData_"+filenameTimestamp+".png";
	    
	    	
	    	try{
		    	Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
		    	writer.write("Logging initiated at " + timestampHeading+System.lineSeparator());
		    	writer.write("Synchronizing program with system clock..." + System.lineSeparator());
		    	writer.write(System.lineSeparator());
		    	writer.write(timeInSeconds + " samples recorded." + System.lineSeparator());
		    	writer.write("-------------------------------------" + System.lineSeparator());
		    	writer.write("Time \t Resistance \t Temperature" + System.lineSeparator());
		    	
		    	writer.close();
	    	}
	    	catch (IOException e) {
		    	 
	    	    e.printStackTrace();
	    	}
    	}
    	else{
    		filenameComp = "log\\Comparison\\LogData_"+filenameTimestamp+".txt";
        	
    	    
        	
        	try{
	        	Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameComp)));
	        	writer.write("Logging initiated at " + timestampHeading+System.lineSeparator());
	        	writer.write("Synchronizing program with system clock..." + System.lineSeparator());
	        	writer.write(System.lineSeparator());
	        	if(channel == "scope"){
		        	writer.write("Scope channel: " + timeInSeconds + " samples recorded." + System.lineSeparator());
	        	}
	        	else{
		        	writer.write("Ext channel: " + timeInSeconds + " samples recorded." + System.lineSeparator());
	        	}
	        	writer.write("-------------------------------------" + System.lineSeparator());
	        	writer.write("Time \t float \t double \t string" + System.lineSeparator());
	        	
	        	writer.close();
        	}catch (IOException e) {
    	    	 
        	    e.printStackTrace();
        	}
    	}
    	
    }
        
    public void createBackupFile(int workstation) throws Exception{  

    		    switch(workstation){
     	    	case 1:
     	    		System.out.print("Backup to Desktop Computer @ NTNU chosen.\n");
     	    		createBackupDesktop();
     	    		break;
     	    	case 2: 
     	    		System.out.print("Backup to Laptop chosen.\n");
     	    		createBackupLaptop();
     	    		break;
     			default:
     				System.out.println("Something went wrong...");
     				System.exit(0);
     				break;
     	    	
     	    	}
    		
    		
    	    
		
    }
     
 	public void generateTimeHeaders(){
 		date = new Date();
    	    	
    	sdfHeading = new SimpleDateFormat("dd.MM.yyyy 'at' HH:mm:ss"); 		//Start time
    	sdfTimestamp = new SimpleDateFormat("dd-MMM-yyyy HH:mm:ss");					//Current time @ sample
    	sdfFilename = new SimpleDateFormat("yyyy_MM_dd" + "; " + "HHmm");	//FilenameTimestamp
    	//sdfTimestampRealTime = new SimpleDateFormat("dd-MMM-yyyy HH:mm:ss.SSS");
    	
    	
    	timestampHeading = 	""+sdfHeading.format(date);
    	
    	//if(realtime == true){
    		//timestamps = ""+sdfTimestampRealTime.format(Calendar.getInstance().getTimeInMillis());
    	//}else if(realtime == false){
    		timestamps = ""+sdfTimestamp.format(date);
    	//}
    	filenameTimestamp = ""+sdfFilename.format(date);
 	}
    
    public void createBackupDesktop() throws Exception{

    	logLength(DynamicPlot.timeSpecifier);
    	generateTimeHeaders();
    	if(comparison == false){
	    	filenameBackup = "C:\\Users\\roartn\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\LogData_"+filenameTimestamp+".txt";
	    	filenamePNGbackup = "C:\\Users\\roartn\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\PNG\\LogData_"+filenameTimestamp+".png";
	    	
	    	
	    	
	    	try{
	    	Writer writerBackup = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameBackup)));
	    	writerBackup.write("Logging initiated at " + timestampHeading+System.lineSeparator());
	    	writerBackup.write("Synchronizing program with system clock..." + System.lineSeparator());
	    	writerBackup.write(System.lineSeparator());
	    	writerBackup.write(timeInSeconds + " samples recorded." + System.lineSeparator());
	    	writerBackup.write("-------------------------------------" + System.lineSeparator());
	    	writerBackup.write("Time \t Resistance \t Temperature" + System.lineSeparator());
	    	
	    	writerBackup.close();
	    	}catch (FileNotFoundException ex){
	    		System.err.println("## System can't find directory path: " + filenameBackup);
	    		System.out.println("Are you sure you specified the right workstation?");
	    		
	    	}catch (IOException e) {
		    	 
	    	    e.printStackTrace();
	    	}
    	}else{
    		filenameCompBackup = "C:\\Users\\roartn\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\Comparison\\LogData_"+filenameTimestamp+".txt";
	    	filenamePNGbackup = "C:\\Users\\roartn\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\PNG\\LogData_"+filenameTimestamp+".png";

	    	
	    	
	    	
	    	try{
	    	Writer writerBackup = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameCompBackup)));
	    	writerBackup.write("Logging initiated at " + timestampHeading+System.lineSeparator());
	    	writerBackup.write("Synchronizing program with system clock..." + System.lineSeparator());
	    	writerBackup.write(System.lineSeparator());
	    	if(channel == "scope"){
	        	writerBackup.write("Scope channel: " + timeInSeconds + " samples recorded." + System.lineSeparator());
        	}
        	else{
	        	writerBackup.write("Ext channel: " + timeInSeconds + " samples recorded." + System.lineSeparator());
        	}
	    	writerBackup.write("-------------------------------------" + System.lineSeparator());
	    	
	    	writerBackup.write("Time \t float \t double \t string" + System.lineSeparator());
	    	
	    	writerBackup.close();
	    	}catch (FileNotFoundException ex){
	    		System.err.println("## System can't find directory path: " + filenameCompBackup);
	    		System.out.println("Are you sure you specified the right workstation?");
	    		
	    	}catch (IOException e) {
		    	 
	    	    e.printStackTrace();
	    	}
    	}
    	
    	
    }
    
    public void createBackupLaptop() throws Exception{

    	logLength(DynamicPlot.timeSpecifier);
    	generateTimeHeaders();
    	
    	if(comparison == false){
    	
    	try {
			filenameBackup = "C:\\Users\\Roar\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\LogData_"+filenameTimestamp+".txt";
			filenamePNGbackup = "C:\\Users\\Roar\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\PNG\\LogData_"+filenameTimestamp+".png";
		}catch (Exception e1) {
			e1.printStackTrace();
		}
    	
    	try{
    	Writer writerBackup = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameBackup)));
    	writerBackup.write("Logging initiated at " + timestampHeading+System.lineSeparator());
    	writerBackup.write(System.lineSeparator());
    	writerBackup.write("Synchronizing program with system clock..." + System.lineSeparator());
    	writerBackup.write(System.lineSeparator());
    	writerBackup.write(timeInSeconds + " samples recorded." + System.lineSeparator());
    	writerBackup.write("-------------------------------------" + System.lineSeparator());
    	writerBackup.write("Time \t Ext \t Temperature" + System.lineSeparator());
    	
    	writerBackup.close();
    	
    	}catch (FileNotFoundException ex){
    		System.err.println("## System can't find directory path: " + filenameBackup);
    		System.out.println("Are you sure you specified the right workstation?");
    		//createBackupFile();
		}catch (IOException e) {
	    	 
    	    e.printStackTrace();
    	}
    	}else{
    		try {
    			filenameCompBackup = "C:\\Users\\Roar\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\Comparison\\LogData_"+filenameTimestamp+".txt";
    			filenamePNGbackup = "C:\\Users\\Roar\\Google Drive\\NTNU\\Vr 2017\\Java\\Java101\\drdaqJava\\log\\PNG\\LogData_"+filenameTimestamp+".png";

    		}catch (Exception e1) {
    			e1.printStackTrace();
    		}
        	
        	try{
        	Writer writerBackup = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameCompBackup)));
        	writerBackup.write("Logging initiated at " + timestampHeading+System.lineSeparator());
        	writerBackup.write(System.lineSeparator());
        	writerBackup.write("Synchronizing program with system clock..." + System.lineSeparator());
        	writerBackup.write(System.lineSeparator());
        	if(channel == "scope"){
	        	writerBackup.write("Scope channel: " + timeInSeconds + " samples recorded." + System.lineSeparator());
        	}
        	else{
	        	writerBackup.write("Ext channel: " + timeInSeconds + " samples recorded." + System.lineSeparator());
        	}
        	writerBackup.write("-------------------------------------" + System.lineSeparator());
        	writerBackup.write("Time \t float \t double \t string" + System.lineSeparator());
        	
        	writerBackup.close();
        	
        	}catch (FileNotFoundException ex){
        		System.err.println("## System can't find directory path: " + filenameCompBackup);
        		System.out.println("Are you sure you specified the right workstation?");
        		//createBackupFile();
    		}catch (IOException e) {
    	    	 
        	    e.printStackTrace();
        	}
    		
    	}
    	
    }
    
    //takes float, double and string and logs it into a single file to enable comparison over long time
    public void writeToFileComparison(){ 
	
    	
    	try{ 
   
	    	
	    	Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameComp,true)));
    		Writer writerBackup = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameCompBackup,true)));

	    	
    		
    		if(channel == "scope"){
    			writer.write( timestamps + "\t" + readOutScope + "\t" + logdataScope + "\t" + convertFloatsToDoublesDATAscope(dataScope));
       		 writer.write(System.lineSeparator());
                            
                
                
                writerBackup.write( timestamps + "\t" + readOutScope + "\t" + logdataScope + "\t" + convertFloatsToDoublesDATAscope(dataScope));
                writerBackup.write(System.lineSeparator());
       		
        	}
        	else{
        		writer.write( timestamps + "\t" + readOutExt + "\t" + logdataExt+ "\t" + convertFloatsToDoublesDATAext(dataExt));
          		 writer.write(System.lineSeparator());
                               
                   
                   
                   writerBackup.write( timestamps + "\t" + readOutExt + "\t" + logdataExt + "\t" + convertFloatsToDoublesDATAext(dataExt));
                   writerBackup.write(System.lineSeparator());
        	}
    		
    		 
    		
 
	    	
	    	writer.close();
	    	writerBackup.close();
	    	

    	}catch (IOException e) {
	    	 
	    	    e.printStackTrace();
	    	}
    }
    
    //Generating and writing file with logged values
    public void writeToFILE(){  


    	
    	try{ 
   
	    	
	    	Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename,true)));
    		Writer writerBackup = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filenameBackup,true)));

	    	
    		
    		
    		
	    	writer.write(timestamps+"\t"+ convertFloatsToDoublesDATAext(dataExt));
    		if(sample%5 == 0){
    			writer.write("\t" + convertFloatsToDoublesTEMP(temp));
         	}
    		writer.write(System.lineSeparator());
	    	   		
    		
    		
    		
    		
    		writerBackup.write(timestamps+"\t"+convertFloatsToDoublesDATAext(dataExt));
        	if(sample%5 == 0){
    			writerBackup.write("\t" + convertFloatsToDoublesTEMP(temp));
         	}
    		writerBackup.write(System.lineSeparator());
    		
    		
    		
    		
	    	
	    	//When logging is done, write average and print success!
    		
	    	if(iteration+1==timeInSeconds)	{
	    		
	    		
	    		
	    		
	    		ChartUtilities.saveChartAsPNG(new File(filenamePNG), DynamicPlot.chart, 2000, 1000);
	    		
	    		
	    		ChartUtilities.saveChartAsPNG(new File(filenamePNGbackup), DynamicPlot.chart, 2000, 1000);

	    		
	    		
	    		Date endDate = new Date();
	    		sdfEnding = new SimpleDateFormat("dd.MM.yyyy' at 'HH:mm:ss");
	        	timestampEnding = ""+sdfEnding.format(endDate);
//	    		//Averages the FSR data
//	        	
//	        	double sumScope = 0;
//	        	for(double n : convertDataStorageToDoubleScope(dataStorageScope)){
//	        		sumScope += n;
//	        	}
//	    		double meanScope = (1.0d * sumScope)/dataStorageScope.length;
//	    		
//	    		

	        	//Averages the FSR data
	        	double sumExt = 0;
	        	for(double n : convertDataStorageToDoubleExt(dataStorageExt)){
	        		sumExt += n;
	        	}
	        	double meanExt = (1.0d * sumExt)/dataStorageExt.length;
		    
	    		writer.write("-------------------------------------" + System.lineSeparator());
		    	writer.write("Logging ended successfully on " + timestampEnding + System.lineSeparator());
		    	//writer.write("Scope mean:\t" + dataFormat.format(meanScope) + "V"+ System.lineSeparator());
		    	writer.write("Ext mean:\t" + dataFormat.format(meanExt) + "V");
		    	
		    	System.out.println(System.lineSeparator() + "...Log file saved at C:\\Users\\roartn\\workspace\\drdaqJava\\log");
		    	System.out.println(System.lineSeparator() + "...PNG file saved at C:\\Users\\roartn\\workspace\\drdaqJava\\log\\PNG" + System.lineSeparator());
		    	
		    	writerBackup.write("-------------------------------------" + System.lineSeparator());
		    	writerBackup.write("Logging ended successfully on " + timestampEnding + System.lineSeparator());
		    	//writerBackup.write("Scope mean:\t" + dataFormat.format(meanScope) + "V"+ System.lineSeparator());
		    	writerBackup.write("Ext mean:\t" + dataFormat.format(meanExt) + "V");
		    	
		    	System.out.println("...Backup log file saved at Google Drive\\Java\\Java101\\drdaqJava\\log" + System.lineSeparator());
		    	System.out.println("...Backup PNG file saved at C:\\Users\\roartn\\workspace\\drdaqJava\\log\\PNG" + System.lineSeparator());
	    	
	    	}
	    	
	    	
	    	
	    	writer.close();
	    	writerBackup.close();

	    	
    	}catch (IOException e) {
	    	 
	    	    e.printStackTrace();
	    	}
    	}
    
    //User specifies duration of log session
    public void logLength(int timeSpec){   

    	timeInSeconds = 0;
    	
    	
    	switch(timeSpec){
    	
    	case 1:
    		timeInSeconds = DynamicPlot.timeValue*3600;
    		break;
    	case 2:
    		timeInSeconds = DynamicPlot.timeValue*60;
    		break;
    	case 3:
    		timeInSeconds = DynamicPlot.timeValue;
    		break;
    	case 4:
    		int infinite = 99999999;
    		while (timeInSeconds<=infinite){
    			timeInSeconds++;
    		}
    		break;
    	
    	default:
    		System.out.println("Invalid input, software will terminate.");
    		System.exit(0);
    		break;
    		
    	}
    	System.out.println("    ");
    	System.out.println("    ");
    	System.out.println("-------------------------------------");
    	
    }
    
    //Synchronizing program with system clock to avoid skipping seconds in log file
    public void synchronize(){
    	System.out.println("Synchronizing program with system clock...");
    	System.out.println("");
    	long millis = System.currentTimeMillis();
    	try {
			Thread.sleep(1000-millis%1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
  
    }
  
    
    
    
    
    
	//Store and convert Scope-values for calculating mean at end of log session
	public double[] convertDataStorageToDoubleScope(float[] data){
		 if (data == null)
         {
             return null; 
         }
        double[] meanData = new double[timeInSeconds];
        
        for (int i = 0; i < timeInSeconds; i++){
            meanData[i] = dataStorageScope[i];
        }
        
        return meanData;
	}
	
	//Store and convert Ext-values for calculating mean at end of log session
	public double[] convertDataStorageToDoubleExt(float[] data){
		 if (data == null)
        {
            return null; 
        }
       double[] meanData = new double[timeInSeconds];
       
       
       for (int i = 0; i < timeInSeconds; i++){
           meanData[i] = dataStorageExt[i];
       }
       
       return meanData;
	}

    //Convert to double to be able to round to nearest decimal of choice, and return String
 	public String convertFloatsToDoublesDATAscope(float data){
     	
        double logDataScope = data;
       //Setting decimal format for FSR value
     	dataFormat = new DecimalFormat("0.000");
     	dataFormat.setRoundingMode(RoundingMode.HALF_DOWN);
     	//Rounding FSR values to nearest millivolt
     	final String rounded = dataFormat.format(logDataScope); 
     	
     	return rounded;
     }
 	
 	//Convert to double to be able to round to nearest decimal of choice, and return String
 	public String convertFloatsToDoublesDATAext(float data){
     	
        double logDataExt = data;
       //Setting decimal format for FSR value
     	dataFormat = new DecimalFormat("0.000");
     	dataFormat.setRoundingMode(RoundingMode.HALF_DOWN);
     	//Rounding FSR values to nearest millivolt
     	final String rounded = dataFormat.format(logDataExt); 
     	
     	return rounded;
        
         
     }
 	
 	
 	
 	
     //Convert to double to be able to round to nearest decimal of choice
     public String convertFloatsToDoublesTEMP(float temp){ 
     	
     	double logTemp = temp;	
     	   	
   
    	//Setting decimal format for temperature
    	tempFormat = new DecimalFormat("00.0");
    	tempFormat.setRoundingMode(RoundingMode.HALF_DOWN);
    	
    	//Rounding Temperature to nearest 1 decimal
    	String roundedTemp = tempFormat.format(logTemp);
    	return roundedTemp;
     }


     
   //Convert to double to be able to round to nearest decimal of choice, and return String
  	public String averageFSR(float data){
  	     	
  	 		dataFormat = new DecimalFormat("0.000");
  	     	dataFormat.setRoundingMode(RoundingMode.HALF_DOWN);
  	     	
  	     	
  	 		averageData[count] = (float) data;
  	 		double averageSum = 0;
  	 		int n = 0;
  	 		for(n = 0; n< count; n++){
  	 			averageSum = averageSum + averageData[n];
  	 		}
  	 		fsrAverageValue = (1.0d * averageSum)/count;
  	 		
  	     	
  	     	final String rounded = dataFormat.format(fsrAverageValue); 
  	     	
  	     	
  	     	
  	     	
  	     	return rounded;
  	        
  	         
  	     }
      
  	
  	public String[] average10FSR(float data){
  		String[] average = {};
  		
  		
  		
  		return average;
  	}
     
     
    
}//end of class


