package com.prediktormedical.drdaq.jni;

import java.util.Map;

public class JavaAdapter4DrDAQ {
	public native int openDrDAQ();
	public native void closeDrDAQ();
	public native float readExt1();
	public native float readExt2();
	public native float readExt3();
	public native float readScope();
	public native float readTemp();
	public native float readResistance();
	public native void setDigitalOutput(int channel, int value);
	
	
	
	
	private static boolean libLoaded = false;
	
	public JavaAdapter4DrDAQ() throws Exception {
		if(libLoaded == false){//Load the library
			System.out.println("DrDAQ native lib load");
			String osName = System.getProperty("os.name");
			System.out.println("OS name:"+osName);
			System.out.println("java.library.path:"+System.getProperty("java.library.path"));
	        Map<String, String> envVars = System.getenv();
	        System.out.println("Path:"+envVars.get("Path"));
	        if(envVars.containsKey("LD_LIBRARY_PATH")){
	        	System.out.println("LD_LIBRARY_PATH: " + envVars.get("LD_LIBRARY_PATH"));
	        }
	        try{
		    	if (osName.startsWith("Windows")) { 
			        System.loadLibrary("usbdrdaqjni");  
			    }
		        else if (osName.startsWith("Linux")) {
		        	System.loadLibrary("usbdrdaqjni"); 
		        }
		        else{    
			        System.loadLibrary("usbdrdaqjni"); 
			    }
		    	System.out.println("Native lib loaded");
		    	libLoaded = true;
		        
			}
			catch(UnsatisfiedLinkError u) {
	            u.printStackTrace();
	        } catch(SecurityException s) {
	            s.printStackTrace();
	        } catch(Exception e){
	        	e.printStackTrace();
	        }
		}
		if(libLoaded==false){
			throw new Exception("Unable to load native DrDAQ lib");
		}
		
	}
	
}
